<?php
include('config/generateAccessToken.php');


function sendMessage($target, $title, $body) {
    //firebase project id
    $projectId = "145596017228";
    $accessToken = generateAccessToken();
    // Determine if the target is a token or a topic
    $message = [
        'message' => [
            'notification' => [
                'title' => $title,
                'body' => $body,
            ],
        ],
    ];

    if (strpos($target, '/topics/') === 0) {
        // If the target starts with '/topics/', it's a topic
        $message['message']['topic'] = substr($target, 8); // Remove '/topics/' prefix
    } else {
        // Otherwise, it's a token
        $message['message']['token'] = $target;
    }

    $jsonMessage = json_encode($message);

    $options = [
        'http' => [
            'header' => [
                "Authorization: Bearer $accessToken",
                "Content-Type: application/json",
            ],
            'method' => 'POST',
            'content' => $jsonMessage,
        ],
    ];

    $context = stream_context_create($options);
    $result = file_get_contents("https://fcm.googleapis.com/v1/projects/$projectId/messages:send", false, $context);

    return $result;
}

?>